<?php
class default_real_media_library_folder_box {
    private $plugin;
    
    private $allowLastQueried;
    
    public function __construct($parent) {
        $this->plugin = $parent;
        $this->allowedLastQueried = false; // function_exists('wp_rml_last_queried_folder');
    }
    
    // overrides IUserSettings
	public function content($content, $user) {
		$default = $this->plugin->getDefaultFolder();
		$selectedNo = $default == "-2" ? 'selected="selected"' : "";
		$selectedLastQueried = $default == "-3" ? 'selected="selected"' : "";
        $content .= '<tr>
            <th scope="row">Default startup folder (deprecated)</th>
            <td>
                <select name="defaultFolder">
                	<option value="-2" ' . $selectedNo . '>No folder at startup</option>
                	' . ($this->allowedLastQueried ? '<option value="-3" ' . $selectedLastQueried . '>Last queried folder</option>' : '') . '
                	' . wp_rml_dropdown($default, array()) . '
                </select>
            </td>
        </tr>
        <tr class="rml-meta-margin"></tr>';
        
        return $content;
    }
    
    // overrides IUserSettings
    public function save($response, $user, $request = null) {
        $param = null;
        if ($request === null) {
            $param = isset($_POST["defaultFolder"]) ? $_POST["defaultFolder"] : null;
        }else{ // V4 compatibility
            $param = $request->get_param("defaultFolder");
        }
        
        if ($param !== null) {
        	update_user_meta($user, "rmlDefaultFolder", $param);
        }
        return $response;
    }
    
    // overrides IUserSettings
    public function scripts() {
        // Silence is golden.
    }
}
?>