/* global jQuery rmlOpts wp rml */
jQuery(function($) {
    var isV4 = !!rmlOpts.version;
    
    var defaultFolder = rmlOpts.defaultFolder,
        defaultFolderRefresh = !!+rmlOpts.defaultFolderRefresh,
        fnChange = function(df) {
            $('#menu-media a[href^="upload.php"]').attr("href", df ? "upload.php?rml_folder=" + df : 'upload.php');
        };
    
    // Modify menu link
    window.rml.hooks.register("ready", function() {
        fnChange(defaultFolder);
    });
    
    if (isV4) {
        rml.store.setter(function(self) {
            // No folder at startup
            self.staticTree.push({
                id: -2,
                title: 'none',
                $visible: false,
                properties: {
                    type: -2
                }
            });
        });
        
        window.rml.hooks.register('usersettings', function(response, fields) {
            fnChange(fields.defaultFolder);
        }).register('tree/select', function(id) {
            defaultFolderRefresh && fnChange(id === 'all' ? '' : id);
        });
    }else{
        window.rml.hooks.register("usersettings/save/success", function(response, fields) {
            fnChange(fields.defaultFolder);
        });
        
        // Modify lazy loader
        if (defaultFolder === "-2") {
            window.rml.hooks.register("tree/afterInit", function() {
                $(this).allInOneTree("loader", false); 
            });
        }
        
        // Modify modal containers and deselect "All files" to avoid multiple switchFolder events
        window.rml.hooks.register("tree/prepare/modal", function(container, isAlreadyLoaded, customSelectToChange) {
            if (!isAlreadyLoaded && defaultFolder !== "") {
                container.find('a[data-aio-id=""]').removeClass("active");
            }
        });
        
        // Modify grid and set default filter
        window.rml.hooks.register("grid/toolbar/default", function(filters) {
            if (defaultFolder !== "-2" && filters[defaultFolder]) {
                this.model.set(filters[defaultFolder].props, { silent: false } );
                return;
            }
            if (defaultFolder === "") {
                this.model.set(filters["all"].props, { silent: false } );
                return;
            }
            this.model.set(filters["defaultNone"].props, { silent: false } );
        });
        
        // Modify grid and add default filter
        window.rml.hooks.register("grid/toolbar/filters", function(filters) {
            filters.defaultNone = {
        		text:  "None",
        		props: {
        			rml_folder: -2,
        			rml_type: ""
        		},
        		priority: 10
        	};
        });
    }
    
    if (wp && wp.media) {
        var AttachmentsBrowser = wp.media.view.AttachmentsBrowser,
            oldCreateAttachments = AttachmentsBrowser.prototype.createAttachments,
            oldUpdateContent = AttachmentsBrowser.prototype.updateContent;
    	wp.media.view.AttachmentsBrowser = AttachmentsBrowser.extend({
    	    // Create label for select folder
    	    createAttachments: function() {
    	        oldCreateAttachments.apply(this, arguments);
    			this.attachmentsSelectFolder = new wp.media.View({
    				controller: this.controller,
    				tagName: 'p'
    			});
    
    			this.attachmentsSelectFolder.$el.addClass( 'hidden no-media' );
    			this.attachmentsSelectFolder.$el.html( defaultFolder === "-2" ?
    			    rmlOpts.lang.defaultFolderNoneLabel :
    			    rmlOpts.lang.defaultFolderLoadingLabel );
    			
    			if (!this.controller.isModeActive("grid")) {
    			    this.attachmentsSelectFolder.$el.css({
    			        "color": "#666",
                        "font-size": "18px",
                        "padding": "30px 0 0 20px"
    			    });
    			}
    
    			this.views.add( this.attachmentsSelectFolder );
    	    },
    	    // Update handler to show created label
    	    updateContent: function() {
    	        oldUpdateContent.apply(this, arguments);
    	        
    	        var noItemsView = this.controller.isModeActive("grid") ? this.attachmentsNoResults : this.uploader;
    	        
    	        if (this.dfd) {
    	            this.dfd.done(function() {
    	                var attributes = this.collection.props.attributes;
    	                if (attributes && attributes.rml_folder === -2) {
    	                    noItemsView.$el.addClass("hidden");
    	                    this.attachmentsSelectFolder.$el.removeClass("hidden");
    	                }else{
    	                    this.attachmentsSelectFolder.$el.addClass("hidden");
    	                }
    	            }.bind(this));
    	        }
    	    }
    	});
    }
});